'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Created by asafdavid on 01/03/2017.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */


var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Message = function () {
  function Message(msg) {
    _classCallCheck(this, Message);

    // Deconstruct msg and assign variables
    var fields = msg.fields,
        properties = msg.properties,
        content = msg.content;

    var _properties$headers = properties.headers,
        context = _properties$headers.context,
        headers = _objectWithoutProperties(_properties$headers, ['context']);

    this.fields = fields;
    this.properties = _lodash2.default.omit(properties, 'headers');
    this.headers = headers;
    this.context = context;
    this.content = JSON.parse(content.toString());
    this.meta = _lodash2.default.cloneDeep(_lodash2.default.get(headers, 'meta', {}));

    // Expose topic
    this.topic = _lodash2.default.get(msg, 'properties.headers.topic', '');

    // Store the raw message
    this.raw = msg;
  }

  /**
   * Extracts an option object based on rabbit-task message format
   * @param additionalOptions
   * @returns {{}}
   */


  _createClass(Message, [{
    key: 'toRabbitOptions',
    value: function toRabbitOptions(additionalOptions) {
      var headers = this.headers || {};
      headers.topic = this.headers.replyToTopic || this.topic;
      headers.context = this.context || {};
      var correlationId = this.properties.messageId;

      var options = _extends({
        correlationId: correlationId,
        messageId: correlationId,
        headers: headers
      }, this.properties, additionalOptions);

      return options;
    }
  }]);

  return Message;
}();

exports.default = Message;