'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _events = require('events');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _chance = require('chance');

var _chance2 = _interopRequireDefault(_chance);

var _logger = require('./logger');

var _logger2 = _interopRequireDefault(_logger);

var _postgresPuller = require('./puller/postgresPuller');

var _postgresPuller2 = _interopRequireDefault(_postgresPuller);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created by asafdavid on 08/12/2015.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var chance = new _chance2.default();
var DEFAULT_CONSUMER_QOS = 10;

var Listener = function (_EventEmitter) {
  _inherits(Listener, _EventEmitter);

  function Listener(channel, queue, consumerTag, qosLimit, pullOptions) {
    _classCallCheck(this, Listener);

    var _this = _possibleConstructorReturn(this, (Listener.__proto__ || Object.getPrototypeOf(Listener)).call(this));

    _this.channel = channel;
    _this.queue = queue;
    _this.consumerTag = consumerTag;
    _this.qosLimit = qosLimit || DEFAULT_CONSUMER_QOS;
    _this.puller = _lodash2.default.isEmpty(pullOptions) ? undefined : new _postgresPuller2.default(pullOptions);
    return _this;
  }

  /**
   * Start consuming messages
   */


  _createClass(Listener, [{
    key: 'start',
    value: function start() {
      var _this2 = this;

      _logger2.default.instance.log('[AMQP] Listener starts');
      var options = { noAck: false };
      var hasConsumerTag = !!this.consumerTag;
      options = hasConsumerTag ? _lodash2.default.extend(options, { consumerTag: this.consumerTag + '-' + chance.hash({ length: 5 }) }) : options;

      if (!this.puller) {
        _logger2.default.instance.info('[AMQP] Listener starts in *Push* mode. QOS: ' + this.qosLimit);

        this.channel.prefetch(this.qosLimit);

        return this.channel.consume(this.queue, function (msg) {
          return _this2.processMsg(msg);
        }, options).then(function (fields) {
          _this2.consumerTag = fields.consumerTag;
        });
      }

      _logger2.default.instance.info('[AMQP] Listener starts in *Pull* mode');
      return this.puller.start(this.channel, this.queue, function (msg) {
        return _this2.processMsg(msg);
      });
    }

    /**
     * Processes the next msg
     * @param msg
     */

  }, {
    key: 'processMsg',
    value: function processMsg(msg) {
      if (msg) this.emit('msg', msg);
    }

    /**
     * Stops consuming messages
     */

  }, {
    key: 'stop',
    value: function stop() {
      if (this.consumerTag) {
        _logger2.default.instance.info('[AMQP] Listener stops listening to consumer tag', { consumerTag: this.consumerTag });
        return this.channel.cancel(this.consumerTag);
      } else if (this.puller) {
        return this.puller.stop();
      }

      return Promise.resolve();
    }
  }]);

  return Listener;
}(_events.EventEmitter);

exports.default = Listener;