'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Created by asafdavid on 23/02/2017.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */


var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _errio = require('errio');

var Errio = _interopRequireWildcard(_errio);

var _logger = require('../lib/logger');

var _logger2 = _interopRequireDefault(_logger);

var _router = require('../lib/handlers/router');

var _router2 = _interopRequireDefault(_router);

var _baseService = require('./baseService');

var _baseService2 = _interopRequireDefault(_baseService);

var _client = require('../lib/client');

var _client2 = _interopRequireDefault(_client);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Log = _logger2.default.instance;

var RabbitService = function () {
  function RabbitService() {
    _classCallCheck(this, RabbitService);
  }

  _createClass(RabbitService, null, [{
    key: 'register',

    /**
     * Registers a service to a router
     * @param router
     * @param service
     */
    value: function register(router, service) {
      var tasks = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];

      // Verify parameters
      if (!(router && router instanceof _router2.default)) {
        throw new TypeError('router has to be an instance of Router');
      }
      if (!(service && (service instanceof _baseService2.default || service.prototype instanceof _baseService2.default))) {
        throw new TypeError('service has to be an instance of BaseService');
      }

      // Extract handlers
      var handlers = RabbitService._getTasks(service, tasks);
      router.addRoutes(RabbitService.toRabbitHandlers(handlers));
    }

    /**
     * Placeholder to convert handlers to rabbit syntax
     * @param handlers {Object}
     * @returns {*}
     */

  }, {
    key: 'toRabbitHandlers',
    value: function toRabbitHandlers(tasks) {
      var handlers = [];
      _lodash2.default.each(tasks, function (task) {
        var name = task.name,
            topic = task.topic,
            handler = task.handler,
            middleware = task.middleware,
            options = task.options;


        handlers.push({
          name: name,
          pattern: topic,
          middleware: middleware,
          handle: function handle(_ref) {
            var content = _ref.content,
                meta = _ref.meta;
            return handler(content, meta);
          },
          options: options
        });
      });

      return handlers;
    }

    /**
     * Returns a send interface for a specific task
     * @param serviceName
     * @param taskName
     * @param client
     * @param topic
     * @param baseError
     * @param serverMeta
     * @param sync
     * @returns {*}
     */

  }, {
    key: 'getTaskClientInterface',
    value: function getTaskClientInterface(serviceName, taskName, client, topic, baseError, serverMeta, sync, timeout) {
      return sync ? function interfaceSendSync(msg, meta) {
        return RabbitService.sendSync(serviceName, taskName, client, serverMeta, topic, baseError, msg, meta, timeout);
      } : function interfaceSendAsync(msg, meta, context) {
        return RabbitService.sendAsync(serviceName, taskName, client, serverMeta, topic, msg, meta, context);
      };
    }

    /**
     * @param serviceName
     * @param client
     * @param sync
     * @param serverMeta
     * @param [mapping] A mapping object that can be used in order to create methods
     * that wrap the dispatch function, with a specific topic.
     * should be in the form: { taskName: topic }
     * @returns {{}}
     */

  }, {
    key: 'getGenericClient',
    value: function getGenericClient(serviceName, client, sync, serverMeta, mapping) {
      var genericClient = {};

      genericClient.dispatch = sync ? function genericClientSync(topic, msg, meta) {
        return RabbitService.sendSync(serviceName, topic, client, serverMeta, topic, null, msg, meta);
      } : function genericClientAsync(topic, msg, meta, context) {
        return RabbitService.sendAsync(serviceName, topic, client, serverMeta, topic, msg, meta, context);
      };

      // if a mapping object was supplied, create the wrapper methods
      if (mapping) {
        _lodash2.default.mapKeys(mapping, function (topic, taskName) {
          genericClient[taskName] = function (msg, meta, context) {
            return genericClient.dispatch(topic, msg, meta, context);
          };
        });
      }

      return genericClient;
    }

    /**
     * Returns a client to execute the the service's tasks.
     * @param service
     * @param client
     * @param serverMeta
     * @param tasks
     */

  }, {
    key: 'getClient',
    value: function getClient(service, client, serverMeta) {
      var tasks = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : [];

      // Validation
      if (!(service && (service instanceof _baseService2.default || service.prototype instanceof _baseService2.default))) {
        throw new TypeError('service has to be an instance of BaseService');
      }
      if (!(client instanceof _client2.default)) throw new TypeError('client must be an instance of Client');

      if (!(serverMeta && (serverMeta.serverExchangeName || serverMeta.serverQueueName))) {
        throw new TypeError('wrong serverMeta was provided');
      }

      // Build the client object
      var serviceName = service.prototype.constructor.name;
      var wantedTasks = RabbitService._getTasks(service, tasks);
      var clientInterface = {};
      // register class level errors
      var _service$prototype$co = service.prototype.constructor,
          _errors = _service$prototype$co._errors,
          _baseError = _service$prototype$co._baseError;

      var classBaseError = _baseError;
      var classErrors = _errors;
      RabbitService._registerErrors(classErrors, classBaseError);

      _lodash2.default.each(wantedTasks, function (task) {
        var name = task.name,
            topic = task.topic,
            sync = task.sync,
            errors = task.errors,
            baseError = task.baseError,
            timeout = task.timeout;
        // register task lever errors

        RabbitService._registerErrors(errors, baseError);

        clientInterface[name] = RabbitService.getTaskClientInterface(serviceName, name, client, topic, baseError || classBaseError, serverMeta, sync, timeout);
      });

      return clientInterface;
    }

    /**
     * Returns all of the tasks for a specific service
     * @param service
     * @param tasks
     * @returns {*}
     * @private
     */

  }, {
    key: '_getTasks',
    value: function _getTasks(service, tasks) {
      var allTasks = service._tasks || service.prototype._tasks;
      return tasks && !_lodash2.default.isEmpty(tasks) ? _lodash2.default.pick(allTasks, tasks) : allTasks;
    }
  }, {
    key: '_registerErrors',
    value: function _registerErrors(errors, baseError) {
      _lodash2.default.each(errors, function (error) {
        Errio.register(error);
      });
      if (baseError) Errio.register(baseError);
    }

    /**
     * Executes an async task
     * @param serviceName
     * @param taskName
     * @param client
     * @param serverMeta
     * @param topicName
     * @param data
     * @param context
     * @returns {Promise.<T>}
     */

  }, {
    key: 'sendAsync',
    value: function sendAsync(serviceName, taskName, client, serverMeta, topicName, data, meta, context) {
      return client.sendAsync(serverMeta, topicName, data, meta, context).catch(function () {
        var error = 'could not send message to ' + topicName;
        Log.error('[' + serviceName + '/' + taskName + '] - ' + error);
        return _bluebird2.default.reject(new Error(error));
      });
    }

    /**
     * Executes a sync task
     * @param serviceName
     * @param taskName
     * @param client
     * @param serverMeta
     * @param topicName
     * @param baseError
     * @param data
     * @param meta
     * @param timeout
     * @returns {Promise.<T>}
     */

  }, {
    key: 'sendSync',
    value: function sendSync(serviceName, taskName, client, serverMeta, topicName, baseError, data, meta, timeout) {
      return client.sendSync(serverMeta, topicName, data, meta, timeout).then(function (result) {
        var content = result && result.content.toString();
        return content && JSON.parse(content);
      }).catch(function (error) {
        if (error instanceof _bluebird2.default.TimeoutError) {
          return _bluebird2.default.reject(error);
        }

        var errorString = error.content ? error.content.toString() : error.toString();
        error = Errio.parse(errorString);

        // if base error is set and the error isn't an instance of base error
        if (baseError && !(error instanceof baseError)) {
          error = new baseError(error.toString()); // eslint-disable-line new-cap
        }

        // Store metadata on the error to identify the service/task
        error.meta = {
          service: serviceName,
          task: taskName
        };

        Log.error('[' + serviceName + '/' + taskName + '] - error for topic ' + topicName + ': ' + error);
        return _bluebird2.default.reject(error);
      });
    }
  }]);

  return RabbitService;
}();

exports.default = RabbitService;