/**
 * Created by meirshalev on 05/02/2017.
 */
import { Util } from '../../../dist'; // eslint-disable-line import/named
import Constants from '../config/constants';

const queueName = Util.getQueueName(Constants.domain, Constants.queueName);

function configExchanges(conn) {
  return conn.channel.assertExchange(
    Constants.exchangeName,
    'topic',
    { durable: true },
  );
}

function configQueues(conn) {
  return conn.channel.assertQueue(queueName, {
    durable: true,
  });
}

function configBindings(conn) {
  return conn.channel.bindQueue(
    queueName,
    Constants.exchangeName,
    `${Constants.domain}.#`); // bind only topics that are part of our domain
}

export default function configure(conn) {
  return configExchanges(conn)
    .then(() => configQueues(conn))
    .then(() => configBindings(conn))
    .tap(() => console.log('configured Rabbit'));
}
