/**
 * Created by meirshalev on 06/07/2017.
 */
import Promise from 'bluebird';

import { Task, Errors } from '../../src/service/decorator';
import BaseService from '../../src/service/baseService';
import BaseError from './baseError';

@Errors({
  baseError: BaseError,
})
export default class TwilioServiceClassErrors extends BaseService {
  constructor() {
    super('Twilio');
  }

  @Task({
    topic: 'TWILIO.SEND',
    sync: true,
  })
  sendSms({ number, text }) { // eslint-disable-line class-methods-use-this
    return Promise.resolve(`message sent ${text} to ${number}`);
  }
}
